'######################################################################################################################
' Printer Report - Summary
'######################################################################################################################

' Update the Configurable options section below with relevant details

'######################################################################################################################
' Defaults and Declarations
'######################################################################################################################
Dim HtmlBody			'To store html body
Dim	EmailSubject		'To store email Subject
Dim	EmailFrom			'To store email From
Dim	EmailTo				'To store email To
Dim	EmailBcc			'To store email BCC
Dim	EmailCc				'To store email CC
Dim EmailSMTPServer		'To store SMTP Server name or address
Dim Environment			'To store string
Dim HtmlBodyTop			'To store Top Header of HtmlBody
Dim strSystemReport		'To store system report 
Dim SendMail		'Trigger to Send Email
Dim HTMLHeader 		'HTML Page Start
Dim ImageHeader 	'HTML Image Insert
Dim strDirectory 	'Image/Save Directory
Dim ReportOnServers 'servers
Dim SaveAsFile 'savefile
Dim OpenInBrowser 'openreport


'Initialization of connection string and credentials
Set wshShell = WScript.CreateObject( "WScript.Shell" )
strComputerName = wshShell.ExpandEnvironmentStrings( "%COMPUTERNAME%" )

'######################################################################################################################
' Configurable Options
'######################################################################################################################
'Email and Report Description
Environment = "Printer Report"

'Location to save report file and find header.jpg image - blank is current folder
SaveAsFile = True
OpenInBrowser = True
strDirectory = ""

'Initialization of Email Configuration
SendMail = False
EmailSMTPServer = "smtp.mailserver.com"
EmailSubject = Environment
EmailFrom = "printers@printer.com"
EmailTo = "youremail@server.com"
EmailBcc = ""
EmailCc = ""

'Servers for Reporting - Comma Separate array i.e. ("Server1","Server2","Server3")Default is current machine only.
ReportOnServers = Array(strComputerName)


'######################################################################################################################
' Report Generation Procedure
'######################################################################################################################

'Top Header
HtmlHeader = "<html><body><div><STYLE>table{font-family: Verdana;font-size: 8pt;}</STYLE><table border=0 cellspacing=0 cellpadding=0 width=760 ><tr><td></td></tr>"

HtmlBodyTop = "<tr><td><table cellspacing=0 cellpadding=0 align=left width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'><tr style='height:14.25pt;Background:#244062;Color:White;'><td><strong>" & Environment & " for " & Now() & "</strong></tr></table></td></tr>"

'Table with blank Row, no border, no content
HtmlBodyTop = HtmlBodyTop & "<tr><td><table cellspacing=0 cellpadding=0 align=left width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'><tr><td>&nbsp;</td></tr>" & "</table></td></tr>"

strHTMLSystemReport = ""
For each ObjServer in ReportOnServers
		
		wscript.echo "Generating report for " & ObjServer & "..."
			'System Detail Below
			strHTMLSystemReport =  strHTMLSystemReport & "<tr><td><table cellspacing=0 cellpadding=0 align=left width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'><tr style='height:14.25pt;Background:#92D050;'><td>Printers on " & ObjServer & "</td></tr>" & "<tr><td>&nbsp;</td></tr></table></td></tr>" 
			strHTMLSystemReport = strHTMLSystemReport & ReportOnPrinters(ObjServer)
Next

HtmlBody = HtmlBodyTop & strHTMLSystemReport & "</table></div></body></html>"

'Insert Logo in Image Header
ImageHeader = "<tr><td><table cellspacing=0 cellpadding=0 align=left width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'><tr><td align='center'><img src='" & strDirectory & "header.jpg'/></td></tr>" & "</table></td></tr>"
Dim fso
Set fso = CreateObject("Scripting.FileSystemObject")
If fso.FileExists(strDirectory & "header.jpg") then
	HtmlBody = HtmlHeader & ImageHeader & HtmlBody
Else
	HtmlBody = HtmlHeader& HtmlBody
End If 
set fso = nothing

'Save or Email
If SaveAsFile then SaveFile(HtmlBody)
If SendMail then SendEmail(Replace(HtmlBody,strDirectory & "header.jpg","cid:header.jpg"))
wscript.echo "Done"

'######################################################################################################################
' Functions from here generate HTML to show reporting on particular areas of functionality
'######################################################################################################################

Function ReportOnPrinters(mycomp)
	strSystemReport = ""
	wscript.echo "* Report On Printers for " & mycomp
	'on error resume next
	Set objWMIService = GetObject("winmgmts:\\" & mycomp & "\root\CIMV2") 
    Set colInstalledPrinters =  objWMIService.ExecQuery ("Select * from Win32_Printer")
    For Each objPrinter in colInstalledPrinters
		strSystemReport =  strSystemReport & "<tr><td><table border=1 cellspacing=0 cellpadding=0 align=left width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'><tr style='height:14.25pt;Background:#A6A6A6;'><td colspan='2'><b>" & objPrinter.Name & "</b></td></tr>"
		strSystemReport =  strSystemReport & "<tr><td style='width:70px;height:14.25pt;Background:#D9D9D9;'>Status:</td>" & GetPrinterStatus(objPrinter.ExtendedPrinterStatus) & "</tr>"
		strSystemReport =  strSystemReport & "<tr><td style='width:70px;height:14.25pt;Background:#D9D9D9;'>Port:</td><td>" & objPrinter.PortName & "</td></tr>"
		strSystemReport =  strSystemReport & "<tr><td style='width:70px;height:14.25pt;Background:#D9D9D9;'>Model:</td><td>" & objPrinter.DriverName & "</td></tr>"
		strSystemReport =  strSystemReport & "<tr><td style='width:70px;height:14.25pt;Background:#D9D9D9;'>Location:</td><td>" & objPrinter.Location & "</td></tr>"
		strSystemReport =  strSystemReport & "<tr><td style='width:70px;height:14.25pt;Background:#D9D9D9;'>Description:</td><td>" & objPrinter.Comment & "</td></tr>"
		If objPrinter.Shared then 
			strSystemReport =  strSystemReport & "<tr><td style='width:70px;height:14.25pt;Background:#D9D9D9;'>Share Name</td><td>" & objPrinter.ShareName & "</td></tr>"
		End IF
		strSystemReport =  strSystemReport & "</table></td></tr>"
		strSystemReport = strSystemReport & ReportonPrintJobs (mycomp,objPrinter.DriverName)
		strSystemReport = strSystemReport & "<tr><td><table cellspacing=0 cellpadding=0 align=left width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'><tr><td>&nbsp;</td></tr></table></td></tr>"
	Next
	set objWMIService = nothing
	Set colInstalledPrinters = nothing
	ReportOnPrinters = strSystemReport
End Function

Function ReportonPrintJobs(pcomp,pdriver)
Dim strHTML
wscript.echo "* Report On Print Jobs for " & pdriver
strHTML = ""
strHTML =  strHTML & "<tr><td><table border=1 cellspacing=0 cellpadding=0 align=left width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'><tr style='height:14.25pt;Background:#A6A6A6;'><td colspan='7'>Jobs</td></tr>"
strHTML =  strHTML & "<tr style='height:14.25pt;Background:#D9D9D9;'><td>Status</td><td>Document</td><td>Owner</td><td>Pages</td><td>Priority</td><td>Size</td><td>Submitted</td></tr>"
'on Error Resume Next
Set objWMIService2 = GetObject("winmgmts:\\" & pcomp & "\root\CIMV2") 
Set colPrintJobs =  objWMIService2.ExecQuery ("Select * from Win32_PrintJob Where DriverName = '" & pdriver & "'")

                     For Each objPrintJob in colPrintJobs 
                                Set objTimeSubmitted = CreateObject ("WbemScripting.SWbemDateTime")
                                objTimeSubmitted.Value = objPrintJob.TimeSubmitted
                                dtmTimeSubmitted = objTimeSubmitted.GetVarDate(True)
						strHTML = strHTML & "<tr>" & GetPrintJobStatus(objPrintJob.StatusMask) & "<td>" & objPrintJob.Document & "</td><td>" & objPrintJob.Owner & "</td><td>" & objPrintJob.TotalPages & "</td><td>" & objPrintJob.Priority & "</td><td>" & objPrintJob.Size/1000 & "Kb</td><td>" & (dtmTimeSubmitted) & "</td></tr>"

                                Set objTimeSubmitted = nothing

                                
             Next
             
                set colPrintJobs = nothing
                set objWMIService2 = nothing

				strHTML = strHTML & "</table></td></tr>"
ReportonPrintJobs = strHTML
End Function

Function GetPrinterStatus(scode)
Dim code,color
                Select Case int(scode)
                Case 1
                                code = "Other"
								color = "yellow"
                Case 2
                                code = "OK"
								color = "lightgreen"	
                Case 3
                                code = "Idle"
								color = "lightgreen"	
                Case 4
                                code = "Printing"
								color = "lightgreen"	 
				Case 5
                                code = "Warming Up"
								color = "yellow"
                Case 6
                                code = "Stopped Printing"
								color = "red"
                Case 7
                                code = "Offline"
								color = "red"
                Case 8
                                code = "Paused"  
								color = "red"								
                Case 9
                                code = "Error"
								color = "red"
                Case 10
                                code = "Busy" 
								color = "lightgreen"	
                Case 13
                                code = "Processing" 
								color = "lightgreen"	
                Case 15
                                code = "Power Save" 
								color = "lightgreen"	
                Case 18
                                code = "Manual Feed" 
								color = "yellow"									
                Case Else
                                code = scode
								color = "yellow"
                End Select
				GetPrinterStatus = "<td bgcolor='" & color & "'>" & code & "</td>"	
End Function			
Function GetPrintJobStatus(scode)
	Dim code, color
                Select Case int(scode)
                Case 0
                                code = "Ready"
								color = "lightgreen"								
				Case 1
                                code = "Paused"
								color = "red"
				Case 2
                                code = "Error"
								color = "red"
				Case 8
                                code = "Spooling"
								color = "lightgreen"
                Case 16
                                code = "Printing"
								color = "yellow"
				Case 32
                                code = "Offline"
								color = "red"
				Case 64
                                code = "Paper Out"
								color = "red"
				Case 512
                                code = "Blocked Queue"
								color = "red"
				Case 1024
                                code = "User Intervention"
								color = "yellow"
                Case 4096
                                code = "Sent To Printer"
								color = "lightgreen"
                Case Else
                                code = scode
								color = "yellow"
                End Select
		GetPrintJobStatus = "<td bgcolor='" & color & "'>" & code & "</td>"		

End Function
'######################################################################################################################
' Functions from here to collate or export the report
'######################################################################################################################

Function GetCDOFromProperties()
	Dim SMTPServer, SMTPPort, SMTPAuthenticate, SMTPUserName, SMTPPassword, SMTPTimeout, SMTPProxyServer, SMTPProxyBypass
	SMTPServer = EmailSMTPServer
	SMTPPort = "25"
	SMTPAuthenticate = "0"
	SMTPUserName = ""
	SMTPPassword = ""
	SMTPTimeout = "5000"
	SMTPProxyServer = ""
	SMTPProxyBypass = ""

	Set GetCDOFromProperties = ConfigureCDO(SMTPServer, SMTPPort, SMTPAuthenticate, SMTPUserName, SMTPPassword, SMTPTimeout, SMTPProxyServer, SMTPProxyBypass)
	
End Function

Function ConfigureCDO(SMTPServer, SMTPPort, SMTPAuthenticate, SMTPUserName, SMTPPassWord, SMTPTimeout, SMTPProxyServer, SMTPProxyBypass)
    Dim Conf
                
    ' Setup SMTP Options
    Set Conf = CreateObject("CDO.Configuration")   
	
	'Specifies the method used to send messages. 1 - Pickup; 2 - Port. If a local SMTP service is available, this field defaults to 1
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2
	
	'	The pickup directory for the local SMTP service. This value is set automatically when the SMTP service is installed.
	'Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpserverpickupdirectory") = "c:\mailroot\pickup"

	'	The name (DNS) or IP address of the machine hosting the SMTP service through which messages are to be sent.
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = strnullcheck(SMTPPort)
	'	The port on which the SMTP service specified by the smtpserver field is listening for connections. The default and well-known port for an SMTP service is 25.
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = strnullcheck(SMTPServer)	
	'	SMTP is using SSL; Default False
	'Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpusessl") = False

	
	'	0 - Do not auth; 1 - Basic (clear text auth); 2 - Use NTLM authentication (Secure Password Authentication in Microsoft Outlook Express). The current process security context is used to authenticate with the service.
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = strnullcheck(SMTPAuthenticate)		

	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendusername") = strnullcheck(SMTPUserName)		
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendpassword") = strnullcheck(SMTPPassWord)	
	'	The user's email address used when connecting to the SMTP service.
	'Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/sendemailaddress") = "xx@teset.com"

	'	Indicates the number of seconds to wait for a valid socket to be established with the SMTP service before timing out. Default is 30
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = strnullcheck(SMTPTimeout)		

	
	'	The proxy server to use when accessing HTTP resources. Both the name (or IP address) of the proxy machine and the port number must be specified using the format "servername:port."
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/urlproxyserver") = strnullcheck(SMTPProxyServer) '"server:80"
	'	Used to specify that for local addresses, the proxy (set with urlproxyserver) should be bypassed. The value of the string, if set, should only be "&lt;local&gt;". This is the same value used with Internet Explorer when setting a proxy with bypass for local addresses. 
	Conf.Fields.Item("http://schemas.microsoft.com/cdo/configuration/urlproxybypass") = strnullcheck(SMTPProxyBypass) '"&lt;local&gt;"


	Conf.Fields.Update

	Set ConfigureCDO = Conf
End Function

Function strnullcheck(varString)
	If Isnull(varString) Then
		strnullcheck = ""
	Else
		strnullcheck = varString
	End If 	
End Function

Function SendEmail(EmailHtmlBody)
	wscript.echo "Sending Email"
	Set objMessage = CreateObject("CDO.Message")
	objMessage.Configuration = GetCDOFromProperties()
	
	'Email header
	objMessage.Subject = EmailSubject
	objMessage.From = EmailFrom
	objMessage.To = EmailTo
	objMessage.Bcc = EmailBcc
	objMessage.Cc = EmailCc
	
	'Header Image
	Dim fso, Attachment
	Set fso = CreateObject("Scripting.FileSystemObject")
	If fso.FileExists(strDirectory & "header.jpg") then
		Set Attachment = ObjMessage.AddAttachment(fso.GetAbsolutePathName(strDirectory & "header.jpg"))
		Attachment.Fields.Item("urn:schemas:mailheader:Content-ID") = "<header.jpg>" ' set an ID we can refer to in HTML
		Attachment.Fields.Item("urn:schemas:mailheader:Content-Disposition") = "inline" ' "hide" the attachment
		Attachment.Fields.Update
	End If 
	set fso = nothing
	
	objMessage.HTMLBody = EmailHtmlBody
	objMessage.Send
	
	Set objMessage = nothing
	HtmlBody = ""	
End Function

Function SaveFile(FileHtmlBody)
	Dim strYear, strMonth, strDay, strHour, strMinute, strSecond, strMyDate, strMyTime
	wscript.echo "Saving File"

	strYear = Year(Date) 
	strMonth = Month(Date) : If Len(m)=1 Then m = "0" & m : End If
	strDay = Day(Date) : If Len(d)=1 Then d = "0" & d : End If
	strHour = Hour(Time) : If Len(h)=1 Then h = "0" & h : End If
	strMinute = Minute(Time) : If Len(n)=1 Then : n = "0" & n : End If
	strSecond = Second(Time) : If Len(s)=1 Then : s = "0" & s : End If
	strMyDate = strYear & "." & strMonth & "." & strDay
	strMytime = strHour & "." & strMinute & "." & strSecond
	
	Dim oFSO, strFile
	Set oFSO = CreateObject("Scripting.FileSystemObject")
	strFile = Environment & " " & strMyDate & "_" & strMyTime & ".html"
	If not oFSO.FileExists(filename) then 
		Set oTextFile = oFSO.CreateTextFile(strDirectory & strFile)
	Else
		Set oTextFile = oFSO.OpenTextFile (strDirectory & strFile, 2) 
	End If
	oTextFile.Write FileHtmlBody
	oTextFile.Close
	If OpenInBrowser then CreateObject("WScript.Shell").Run Chr(34) & strDirectory & strFile & Chr(34)
End Function